commit bd6963543042ce713d290c23e098de84865a287f
Author: Max Filippov <jcmvbkbc@gmail.com>
Date:   Mon Nov 7 13:58:49 2022 -0800

    gcc: fix PR rtl-optimization/107482
    
    gcc/
            PR rtl-optimization/107482
            * ira-color.c (assign_hard_reg): Only call
            update_costs_from_copies when retry_p is false.
    
    (cherry picked from commit e581490f0cfa80c58d2b648d71a44a597fbe3008)

diff --git a/gcc/ira-color.c b/gcc/ira-color.c
index b0fc159a849..c02af1f7181 100644
--- a/gcc/ira-color.c
+++ b/gcc/ira-color.c
@@ -1956,8 +1956,8 @@ assign_hard_reg (ira_allocno_t a, bool retry_p)
     restore_costs_from_copies (a);
   ALLOCNO_HARD_REGNO (a) = best_hard_regno;
   ALLOCNO_ASSIGNED_P (a) = true;
-  if (best_hard_regno >= 0)
-    update_costs_from_copies (a, true, ! retry_p);
+  if (best_hard_regno >= 0 && !retry_p)
+    update_costs_from_copies (a, true, true);
   ira_assert (ALLOCNO_CLASS (a) == aclass);
   /* We don't need updated costs anymore.  */
   ira_free_allocno_updated_costs (a);

